/* 
 * keypad
 *
 * A suite of communication APIs for web and enterprise applications
 *
 * OpenAPI spec version: v1
 * Contact: fmalka@modulo.co.il
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 */
using System;
using System.Linq;
using System.IO;
using System.Text;
using System.Text.RegularExpressions;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Runtime.Serialization;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using System.ComponentModel.DataAnnotations;
using SwaggerDateConverter = SeriousSIP.Client.SwaggerDateConverter;

namespace SeriousSIP.Model
{
    /// <summary>
    /// fileName s- An array of file names to be played back one after the other.    interval - Time in milliseconds between each play instance.    clearDigitsBuffer - If true, the digits buffer is cleared before the playback.    stopOnDigit - Tf true, the playback is interrupted by any key pressed.    waitForCompletion - If true, the http request will reply only when the playback will be completed, otherwise a webhook shall be used to be notified on completion.
    /// </summary>
    [DataContract]
        public partial class PlayFilesParams :  IEquatable<PlayFilesParams>, IValidatableObject
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="PlayFilesParams" /> class.
        /// </summary>
        /// <param name="fileNames">fileNames.</param>
        /// <param name="interval">interval.</param>
        /// <param name="clearDigitsBuffer">clearDigitsBuffer.</param>
        /// <param name="stopOnDigit">stopOnDigit.</param>
        /// <param name="waitForCompletion">waitForCompletion.</param>
        public PlayFilesParams(List<string> fileNames = default(List<string>), int? interval = default(int?), bool? clearDigitsBuffer = default(bool?), bool? stopOnDigit = default(bool?), string? userContext = default(string?), bool? waitForCompletion = default(bool?))
        {
            this.FileNames = fileNames;
            this.Interval = interval;
            this.ClearDigitsBuffer = clearDigitsBuffer;
            this.StopOnDigit = stopOnDigit;
            this.UserContext = userContext;
            this.WaitForCompletion = waitForCompletion;
        }
        
        /// <summary>
        /// Gets or Sets FileNames
        /// </summary>
        [DataMember(Name="fileNames", EmitDefaultValue=false)]
        public List<string> FileNames { get; set; }

        /// <summary>
        /// Gets or Sets Interval
        /// </summary>
        [DataMember(Name="interval", EmitDefaultValue=false)]
        public int? Interval { get; set; }

        /// <summary>
        /// Gets or Sets ClearDigitsBuffer
        /// </summary>
        [DataMember(Name="clearDigitsBuffer", EmitDefaultValue=false)]
        public bool? ClearDigitsBuffer { get; set; }

        /// <summary>
        /// Gets or Sets StopOnDigit
        /// </summary>
        [DataMember(Name="stopOnDigit", EmitDefaultValue=false)]
        public bool? StopOnDigit { get; set; }

        /// <summary>
        /// Gets or Sets UserContext
        /// </summary>
        [DataMember(Name = "userContext", EmitDefaultValue = false)]
        public string UserContext { get; set; }

        /// <summary>
        /// Gets or Sets WaitForCompletion
        /// </summary>
        [DataMember(Name="waitForCompletion", EmitDefaultValue=false)]
        public bool? WaitForCompletion { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            var sb = new StringBuilder();
            sb.Append("class PlayFilesParams {\n");
            sb.Append("  FileNames: ").Append(FileNames).Append("\n");
            sb.Append("  Interval: ").Append(Interval).Append("\n");
            sb.Append("  ClearDigitsBuffer: ").Append(ClearDigitsBuffer).Append("\n");
            sb.Append("  StopOnDigit: ").Append(StopOnDigit).Append("\n");
            sb.Append("  UserContext: ").Append(UserContext).Append("\n");
            sb.Append("  WaitForCompletion: ").Append(WaitForCompletion).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }
  
        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public virtual string ToJson()
        {
            return JsonConvert.SerializeObject(this, Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="input">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object input)
        {
            return this.Equals(input as PlayFilesParams);
        }

        /// <summary>
        /// Returns true if PlayFilesParams instances are equal
        /// </summary>
        /// <param name="input">Instance of PlayFilesParams to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(PlayFilesParams input)
        {
            if (input == null)
                return false;

            return 
                (
                    this.FileNames == input.FileNames ||
                    this.FileNames != null &&
                    input.FileNames != null &&
                    this.FileNames.SequenceEqual(input.FileNames)
                ) && 
                (
                    this.Interval == input.Interval ||
                    (this.Interval != null &&
                    this.Interval.Equals(input.Interval))
                ) && 
                (
                    this.ClearDigitsBuffer == input.ClearDigitsBuffer ||
                    (this.ClearDigitsBuffer != null &&
                    this.ClearDigitsBuffer.Equals(input.ClearDigitsBuffer))
                ) && 
                (
                    this.StopOnDigit == input.StopOnDigit ||
                    (this.StopOnDigit != null &&
                    this.StopOnDigit.Equals(input.StopOnDigit))
                ) && 
                (
                    this.WaitForCompletion == input.WaitForCompletion ||
                    (this.WaitForCompletion != null &&
                    this.WaitForCompletion.Equals(input.WaitForCompletion))
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            unchecked // Overflow is fine, just wrap
            {
                int hashCode = 41;
                if (this.FileNames != null)
                    hashCode = hashCode * 59 + this.FileNames.GetHashCode();
                if (this.Interval != null)
                    hashCode = hashCode * 59 + this.Interval.GetHashCode();
                if (this.ClearDigitsBuffer != null)
                    hashCode = hashCode * 59 + this.ClearDigitsBuffer.GetHashCode();
                if (this.StopOnDigit != null)
                    hashCode = hashCode * 59 + this.StopOnDigit.GetHashCode();
                if (this.WaitForCompletion != null)
                    hashCode = hashCode * 59 + this.WaitForCompletion.GetHashCode();
                return hashCode;
            }
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        IEnumerable<System.ComponentModel.DataAnnotations.ValidationResult> IValidatableObject.Validate(ValidationContext validationContext)
        {
            yield break;
        }
    }
}
